from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.CMFCorePermissions import ManagePortal
from Products.CMFPlone.migrations.migration_util import safeEditProperty
from Products.PortletBirthday import skin_globals

from cStringIO import StringIO
import string

skinFolders = ('PortletBirthday',)
skinName = 'PortletBirthday'
baseSkin = 'Plone Default'

def setupSkin (self, out):
    skinsTool = getToolByName (self, 'portal_skins')
    
    # Add directory views

    addDirectoryViews (skinsTool, 'skins', skin_globals)
    out.write ("Added directory views to portal_skins.\n")
       
    # Only add if the skin doesn't already exist
    if skinName not in skinsTool.getSkinSelections ():

        # Get the skin paths of the base skin and convert to an array
        path = skinsTool.getSkinPath (baseSkin)
        path = map (string.strip, string.split (path,','))
        
        # Add our own skin folders to this path, under 'custom'
        for skinFolder in skinFolders:
            if skinFolder not in path:
                try: 
                    path.insert (path.index ('custom') + 1, skinFolder)
                except ValueError:
                    path.append (skinFolder)
    
        # Add our skin
        path = string.join (path, ', ')    
        skinsTool.addSkinSelection (skinName, path)
    else:
        out.write ('Skin already exists, leaving it alone')
     
    portal_skins = getToolByName(self, 'portal_skins')
    path = portal_skins.getSkinPath('Plone Default')
    path = [elem.strip() for elem in path.split(',') if elem != '.svn']
    path = ','.join(path)
    portal_skins.manage_properties(default_skin = 'PortletBirthday',
                                   request_varname = 'plone_skin',
                                   del_skin = 0, 
                                   chosen = [] )  

def removeSkin (self, out):

    skinsTool = getToolByName (self, 'portal_skins')
    
    # Delete the property which holds the skin
    if skinName in skinsTool.getSkinSelections ():
        skinsTool.manage_skinLayers (del_skin = 1, chosen = (skinName,))

def installPortlet (self, out):
    #add property in portal_memberdata
    try:
        portal_memberdata = getToolByName(self, 'portal_memberdata')
        portal_memberdata.manage_addProperty(id='data_niver',value='2000/01/01',type='date')
    except:
        pass

    #add portlet in right_slot
    right_slots=( 'here/portlet_review/macros/portlet'
                , 'here/portlet_news/macros/portlet'
                , 'here/portlet_events/macros/portlet'
		, 'here/portlet_niver/macros/portlet' )

    safeEditProperty(self, 'right_slots', right_slots)

def install (self):
    out = StringIO ()

    installPortlet (self, out)
    setupSkin (self, out)
    out.write ('Installation completed.\n')
    return out.getvalue()

def uninstall (self):
    out = StringIO ()

    removeSkin (self, out)
    out.write ('Uninstallation completed.\n')
    return out.getvalue()
